
// position arrays
float x[];
float y[];

float speedX[];
float speedY[];

color colors[]; // array of color values

void setup() {
  size(800, 400, P3D); 

  int num = 200;

  // creates space for position & inits
  x = new float[num];
  y = new float[num];
  speedX = new float[num];
  speedY = new float[num];
  colors = new color[num];
  for(int i = 0; i < x.length; ++i) {
    x[i] = random(width);
    y[i] = random(height);
    speedX[i] = random(-2, 2);
    speedY[i] = random(-2, 2);
    colors[i] = color(
      random(50, 225),   // r
      random(50, 225),   // g
      random(50, 225));  // b
  }

}

void draw() {
  background(200);
  
  for(int i = 0; i < x.length; ++i) {
  
    // update the X position
    x[i] = x[i] + speedX[i];
    if(x[i] < 0) { // left
      x[i] = 0; // reset
      speedX[i] = -speedX[i]; // turn around
    }
    else if(x[i] > width) { // right
      x[i] = width; // reset
      speedX[i] = -speedX[i];
    }
    
    // update the Y position
    y[i] = y[i] + speedY[i];
    if(y[i] < 0) { // top
      y[i] = 0; // reset
      speedY[i] = -speedY[i]; // turn around
    }
    else if(y[i] > height) { // right
      y[i] = height; // bottom
      speedY[i] = -speedY[i];
    }

    // make sure we don't grab the -1 index
    if(i > 0) {
      stroke(colors[i]);
      line(x[i], y[i], x[i-1], y[i-1]);
    }
    
    // draw
    if(mousePressed) {
      noStroke();
      ellipse(x[i], y[i], 12, 12);
    }
  }
}