
PImage pug;
PImage hedgehog;
PImage blended;

void setup() {
  size(800, 400);
  frameRate(30);
  
  // load images
  pug = loadImage("pug.jpg");
  hedgehog = loadImage("hedgehog.jpg");
  blended = loadImage("pug.jpg");
  
  // blend image form hedgehog into pug
  // hedgehog is source, pug is dest
  //blended.blend(hedgehog, // source image
  //              hedgehog.width/2, // half image on x
  //              0, // y
  //              hedgehog.width/2, // half width
  //              hedgehog.height, // full height
  //              blended.width/2, // half way in on x
  //              0, // y
  //              blended.width/2, // half width
  //              blended.height, // full height
  //              BURN);
                
  // draw from the center
  imageMode(CENTER);
}

void draw() {
  background(255);
  
  // blend only when the mouse has moved
  if(mouseX != pmouseX) {
   // compute widths base on each image's pixel size 
   int sw = int(map(mouseX, 0, width, 0, hedgehog.width));
   int dw = int(map(mouseX, 0, width, 0, blended.width));
   blended = pug.copy();
   blended.blend(hedgehog, // source image
                 sw, // part of source on x
                 0, // y
                 hedgehog.width-sw, // other part of source
                 hedgehog.height, // full height
                 dw, // part of dest on x
                 0, // y
                 blended.width-dw, // other part of dest
                 blended.height, // full height
                 DODGE);
  }
  
  // move down to middle of the screen on y axis
  translate(0, height/2);
    
  // draw normal pug
  image(pug, 200, 0, 400, 300);
  
  // draw blended image
  image(blended, 600, 0, 400, 300);
}