import controlP5.*;

ControlP5 gui;

color colorOne;
color colorTwo;
color circleColor;

float angle = 0;
float angleSpeed = 0.01;

void setup() {
  size(400, 400);
  
  gui = new ControlP5(this);
  
  colorOne = color(229, 69, 69);
  colorTwo = color(47, 234, 120);
  circleColor = color(200);
 
  gui.addButton("one")
     .setPosition(10, 10).setSize(40, 40);
  gui.addButton("two")
     .setPosition(width-50, 10)
     .setSize(40, 40);
  gui.addSlider("speed")
     .setPosition(10, height-50)
     .setSize(width-20, 40)
     .setRange(0.001, 0.1);
     
  gui.getController("speed").getCaptionLabel().setVisible(false);
}

void draw() {
  background(100);
  noStroke();
  fill(circleColor);
  float s = abs(sin(angle)) * 100;
  ellipse(width/2, height/2, s, s);
  angle = angle + angleSpeed;
}

public void one(int value) {
  println("one button pressed");
  circleColor = colorOne;
}

public void two(int value) {
  println("two button pressed");
  circleColor = colorTwo;
}

public void speed(float value) {
  println("speed slider changed: "+value);
  angleSpeed = value;
}