
class Subdivision {
  
  House houses[];
  Tree trees[];
  
  float x, y; // position around where things are built
  float spacing; // how far apart things are
  
  // constructor
  Subdivision(float numHouses, float numTrees, float space) {
    
    // choose random location
    x = random(space, width-space);
    y = random(space, height-space);
    
    // initialize arrays
    houses = new House[int(numHouses)];
    trees = new Tree[int(numTrees)];
    
    // set spacing
    spacing = space;
    
    // build houses & grow trees
    for(int i = 0; i < houses.length; ++i) {
      houses[i] = new House(x+random(-spacing, spacing), y+random(-spacing, spacing));
      houses[i].roofColor = color(random(255), random(255), random(255));
      houses[i].roofHeight = random(35, 100); 
    }
    for(int i = 0; i < trees.length; ++i) {
      trees[i] = new Tree(x+random(-spacing, spacing), y+random(-spacing, spacing));
      trees[i].leavesHeight = random(35, 100);
    }
  }
  
  void draw() {
    for(int i = 0; i < houses.length; ++i) {
      House h = houses[i];
      h.draw();
    }
    for(int i = 0; i < trees.length; ++i) {
      trees[i].draw(); 
    }
  }
  
};